      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\fpulib\fpu.inc
      include \masm32\macros\macros.asm
      include \masm32\macros\windows.asm
      include \masm32\include\comdlg32.inc
      include \masm32\include\ws2_32.inc
      include \masm32\include\shell32.inc

      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\fpulib\fpu.lib
      includelib \masm32\lib\ws2_32.lib
      includelib \masm32\lib\shell32.lib


      DialogProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
      DialogProc2 PROTO :DWORD,:DWORD,:DWORD,:DWORD

      ProxyCheck PROTO :DWORD

      PauserInit PROTO :DWORD


      SendPacket PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
      base64_encode PROTO :DWORD, :DWORD, :DWORD, :DWORD
      SocketInit PROTO
      SocketCleanup PROTO
      GetProxy PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

      SaveFileDialog2 PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
      AddLog PROTO :DWORD, :DWORD

      InString2 PROTO :DWORD, :DWORD, :DWORD
      ExceptionHandler PROTO :DWORD

      ShowElems PROTO :DWORD, :DWORD, :DWORD

      istring2 MACRO spos,lpMainString,lpSubString
        invoke InString2,spos,reparg(lpMainString),reparg(lpSubString)
        EXITM <eax>
      ENDM

      NMHDR STRUCT
        hwndFrom DWORD ?
        idFrom DWORD ?
        code DWORD ?
      NMHDR ENDS

      LITEM STRUCT
        imask DWORD ?
        iLink DWORD ?
        state DWORD ?
        stateMask DWORD ?
        szID BYTE [2083] ?
        szUrl BYTE [2083] ?
      LITEM ENDS

      NMLINK STRUCT
        hdr NMHDR <>
        xitem LITEM <>
      NMLINK ENDS



.data
caption db "Proxy Checker Lite",0
path db "  (*.txt)",0,"*.txt",0,"  (*.*)",0,"*.*",0,0
mutexerr db "   .",0
cfield db " ?",0
keyStr db "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",0

memerr db "  ",0
badproxy db "  ",0
fileerr db "  ",0
pausetext db "...",0
zero db 0

protocol dd 0

emptystr db 0

proxy_checker db "proxy_checker",0

user_changing db 1

.data?
divider2 db 4 dup(?)

timeout_val_read dd ?
timeout_val_write dd ?


hInstance dd ?
hWnd dd ?
hWnd2 dd ?

fldid dd ?
tlen dd ?

handles dd 101 dup(?)

thread_count dd ?

hMutex dd ?
hMutex_log dd ?
hMutex_proxy dd ?
hMutex_list dd ?

stopper db ?
pauser db ?
timer_started db ?

lognum dd ?

run_thr dd ?


fname dd ?
iFile dd ?

fDone dd ?

Proxies dd ?
CurrProxy dd ?

proxytype dd ?
ico dd ?

btn2 dd ?

host_address db 256 dup(?)
a_address db 256 dup(?)
search_string db 512 dup(?)
acheck_uri db 256 dup(?)

read_bytes dd ?

service_uri db 256 dup(?)
referer db 256 dup(?)
cookies db 4096 dup(?)
get_post_data dd ?


service_uri_addr dd ?
referer_addr dd ?
cookies_addr dd ?
get_post_data_addr dd ?

acheck db ?

pathbuf db 261 dup(?)
settingsbuf db 256 dup(?)

a_address_custom db 256 dup(?)
acheck_uri_custom db 256 dup(?)

.code

start:
  invoke SetUnhandledExceptionFilter,offset ExceptionHandler
  mov hInstance, FUNC(GetModuleHandleW,NULL)
  call main
  invoke ExitProcess,eax

main PROC
  LOCAL icce:INITCOMMONCONTROLSEX

  mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX
  mov icce.dwICC, ICC_DATE_CLASSES or \
                  ICC_INTERNET_CLASSES or \
                  ICC_PAGESCROLLER_CLASS or \
                  ICC_COOL_CLASSES

  invoke InitCommonControlsEx,ADDR icce

  invoke VirtualAlloc,0,204800,MEM_COMMIT,PAGE_READWRITE
  test eax,eax
  jne @F
    invoke MessageBox,hWnd,chr$("  ."),offset caption,MB_ICONERROR
    ret
  @@:

  mov get_post_data,eax


  mov hMutex,FUNC(CreateMutex,NULL,FALSE,NULL)
  test eax,eax
  jne @F
    invoke MessageBox,0,offset mutexerr,offset caption,MB_ICONERROR
    invoke ExitProcess,0
  @@:

  mov hMutex_log,FUNC(CreateMutex,NULL,FALSE,NULL)
  test eax,eax
  jne @F
    invoke CloseHandle,hMutex
    invoke MessageBox,0,offset mutexerr,offset caption,MB_ICONERROR
    invoke ExitProcess,0
  @@:

  mov hMutex_proxy,FUNC(CreateMutex,NULL,FALSE,NULL)
  test eax,eax
  jne @F
    invoke CloseHandle,hMutex
    invoke CloseHandle,hMutex_log
    invoke MessageBox,0,offset mutexerr,offset caption,MB_ICONERROR
    invoke ExitProcess,0
  @@:

  mov hMutex_list,FUNC(CreateMutex,NULL,FALSE,NULL)
  test eax,eax
  jne @F
    invoke CloseHandle,hMutex
    invoke CloseHandle,hMutex_log
    invoke CloseHandle,hMutex_proxy
    invoke MessageBox,0,offset mutexerr,offset caption,MB_ICONERROR
    invoke ExitProcess,0
  @@:

  call SocketInit

  invoke lstrcpy,offset service_uri,chr$("/")
  invoke lstrcpy,offset referer,offset zero
  invoke lstrcpy,offset cookies,offset zero
  invoke lstrcpy,get_post_data,offset zero

  invoke DialogBoxParam,hInstance,chr$("Check"),0,offset DialogProc,0
  ret
main ENDP


DialogProc2 proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
  LOCAL rnbuf [8] :BYTE
   .if uMsg == WM_INITDIALOG
      invoke SendMessageW,hWin,WM_SETICON,1,ico
      invoke SendDlgItemMessage,hWin,1002,EM_SETLIMITTEXT,255,0
      invoke SendDlgItemMessage,hWin,1003,EM_SETLIMITTEXT,255,0
      invoke SendDlgItemMessage,hWin,1005,EM_SETLIMITTEXT,4095,0
      invoke SendDlgItemMessage,hWin,1007,EM_SETLIMITTEXT,204750,0

      invoke SetDlgItemText,hWin,1002,offset service_uri
      invoke SetDlgItemText,hWin,1003,offset referer
      invoke SetDlgItemText,hWin,1005,offset cookies
      invoke SetDlgItemText,hWin,1007,get_post_data

      .if protocol==1
        mov eax,BST_CHECKED
      .else
        mov eax,BST_UNCHECKED
      .endif

      invoke SendDlgItemMessage,hWin,1009,BM_SETCHECK,eax,0

      m2m hWnd2,hWin

  .elseif uMsg == WM_COMMAND
    .if wParam==1011
      jmp quit_dialog4
    .elseif wParam==1010
      invoke GetDlgItemText,hWin,1002,offset service_uri,255
      invoke GetDlgItemText,hWin,1003,offset referer,255
      invoke GetDlgItemText,hWin,1005,offset cookies,4095
      invoke GetDlgItemText,hWin,1007,get_post_data,204750

      invoke SendDlgItemMessage,hWin,1009,BM_GETCHECK,0,0
      .if eax==BST_CHECKED
        mov protocol,1
      .else
        mov protocol,0
      .endif


      jmp quit_dialog4
    .endif
  .elseif uMsg == WM_CLOSE
    quit_dialog4:
    invoke EndDialog,hWin,0
  .endif

xor eax,eax
ret
DialogProc2 ENDP


changed_selection PROC hWin:DWORD
  invoke SendDlgItemMessage,hWin,1053,CB_GETCURSEL,0,0
  mov user_changing,0
  .if eax == 0
    invoke SetDlgItemText,hWnd,1049,chr$("myip.ru")
    invoke SetDlgItemText,hWnd,1051,chr$("/get_ip.php?loc=")
  .elseif eax == 1
    invoke SetDlgItemText,hWnd,1049,chr$("2ip.ru")
    invoke SetDlgItemText,hWnd,1051,chr$("/")
  .elseif eax == 2
    invoke SetDlgItemText,hWnd,1049,chr$("internet.yandex.ru")
    invoke SetDlgItemText,hWnd,1051,chr$("/")
  .elseif eax == 3
    invoke SetDlgItemText,hWnd,1049,offset a_address_custom
    invoke SetDlgItemText,hWnd,1051,offset acheck_uri_custom
  .endif
  mov user_changing,1
  ret
changed_selection ENDP



DialogProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
LOCAL tempbuf [4096] :BYTE
local prr1 [64] :BYTE
local prr2 [16] :byte
local membuff [512] :byte

  .if uMsg == WM_INITDIALOG
      mov ico,FUNC(LoadIconW,hInstance,1)
      invoke SendMessage,hWin,WM_SETICON,1,eax

      invoke SendDlgItemMessage,hWin,1041,EM_SETLIMITTEXT,1,0
      invoke SendDlgItemMessage,hWin,1031,EM_SETLIMITTEXT,6,0
      invoke SendDlgItemMessage,hWin,1020,EM_SETLIMITTEXT,511,0
      invoke SendDlgItemMessage,hWin,1019,EM_SETLIMITTEXT,255,0
      invoke SendDlgItemMessage,hWin,1015,EM_SETLIMITTEXT,6,0
      invoke SendDlgItemMessage,hWin,1012,EM_SETLIMITTEXT,6,0
      invoke SendDlgItemMessage,hWin,1001,EM_SETLIMITTEXT,-1,0
      invoke SendDlgItemMessage,hWin,1005,EM_SETLIMITTEXT,-1,0
      invoke SendDlgItemMessage,hWin,1007,EM_SETLIMITTEXT,-1,0
      invoke SendDlgItemMessage,hWin,1023,EM_SETLIMITTEXT,-1,0

      invoke SendDlgItemMessage,hWin,1010,UDM_SETRANGE32,1,100

      invoke SendDlgItemMessage,hWin,1010,UDM_SETBASE,1,0

      invoke GetDlgItem,hWin,1003
      invoke SendDlgItemMessage,hWin,1010,UDM_SETBUDDY,eax,0

      invoke GetDlgItem,hWin,1037
      mov btn2,eax

      m2m hWnd,hWin
      mov pauser,0
      mov stopper,0


      invoke SendDlgItemMessage,hWin,1053,CB_ADDSTRING,0,chr$("myip.ru")
      invoke SendDlgItemMessage,hWin,1053,CB_ADDSTRING,0,chr$("2ip.ru")
      invoke SendDlgItemMessage,hWin,1053,CB_ADDSTRING,0,chr$("internet.yandex.ru")
      invoke SendDlgItemMessage,hWin,1053,CB_ADDSTRING,0,chr$("")
      invoke SendDlgItemMessage,hWin,1053,CB_SETCURSEL,0,0

      invoke GetModuleFileName,0,offset pathbuf,261

      push edi
      std
      mov edi,offset pathbuf
      add edi,FUNC(lstrlenA,offset pathbuf)
      mov al,'.'
      repne scasb
      mov byte ptr [edi + 2], 0
      cld
      pop edi
      invoke lstrcat,offset pathbuf,chr$("ini")

  .elseif uMsg==WM_NOTIFY
    mov eax,lParam
    .if (NMHDR.code[eax]==NM_CLICK || NMHDR.code[eax]==NM_RETURN)
      invoke GetDlgItem,hWnd,1090
      mov ebx,eax
      mov eax,lParam
      mov ecx,NMLINK.xitem.iLink[eax]
      mov edx,NMHDR.hwndFrom[eax]

      .if edx==ebx && ecx==0
        invoke ShellExecute,NULL,chr$("open"),chr$("http://kaimi.ru/"), NULL, NULL, SW_SHOW
      .endif
    .endif
  .elseif uMsg == WM_COMMAND
    mov ecx,wParam
    mov edx,ecx
    shr edx,16
    .if (cx == 1049 || cx == 1051) && dx == EN_CHANGE && user_changing == 1
      invoke GetDlgItemText,hWnd,1049,offset a_address_custom,255
      invoke GetDlgItemText,hWnd,1051,offset acheck_uri_custom,255
      invoke SendDlgItemMessage,hWin,1053,CB_SETCURSEL,3,0
    .elseif cx == 1053 && dx == CBN_SELCHANGE
      invoke changed_selection,hWin

    .elseif wParam==1054 ;Save settings
      invoke GetDlgItemText,hWnd,1020,offset search_string,511
      invoke GetDlgItemText,hWnd,1019,offset host_address,255
      invoke GetDlgItemText,hWnd,1041,offset divider2,3

      invoke WritePrivateProfileString,offset proxy_checker,chr$("anon_check_address"),offset a_address_custom,offset pathbuf
      invoke WritePrivateProfileString,offset proxy_checker,chr$("anon_check_uri"),offset acheck_uri_custom,offset pathbuf
      invoke WritePrivateProfileString,offset proxy_checker,chr$("host"),offset host_address,offset pathbuf
      invoke WritePrivateProfileString,offset proxy_checker,chr$("search_string"),offset search_string,offset pathbuf
      invoke WritePrivateProfileString,offset proxy_checker,chr$("divider"),offset divider2,offset pathbuf

      invoke WritePrivateProfileString,offset proxy_checker,chr$("service_uri"),offset service_uri,offset pathbuf
      invoke WritePrivateProfileString,offset proxy_checker,chr$("referer"),offset referer,offset pathbuf
      invoke WritePrivateProfileString,offset proxy_checker,chr$("cookies"),offset cookies,offset pathbuf
      invoke WritePrivateProfileString,offset proxy_checker,chr$("data"),get_post_data,offset pathbuf

      invoke GetDlgItemText,hWnd,1003,offset settingsbuf,250
      invoke WritePrivateProfileString,offset proxy_checker,chr$("threads"),offset settingsbuf,offset pathbuf
      invoke GetDlgItemText,hWnd,1031,offset settingsbuf,250
      invoke WritePrivateProfileString,offset proxy_checker,chr$("read_bytes"),offset settingsbuf,offset pathbuf
      invoke GetDlgItemText,hWnd,1015,offset settingsbuf,250
      invoke WritePrivateProfileString,offset proxy_checker,chr$("read_timeout"),offset settingsbuf,offset pathbuf
      invoke GetDlgItemText,hWnd,1012,offset settingsbuf,250
      invoke WritePrivateProfileString,offset proxy_checker,chr$("write_timeout"),offset settingsbuf,offset pathbuf

      invoke SendDlgItemMessage,hWnd,1004,BM_GETCHECK,0,0
      .if eax==BST_CHECKED
        invoke WritePrivateProfileString,offset proxy_checker,chr$("proxy_type"),chr$("1"),offset pathbuf
      .else
        invoke WritePrivateProfileString,offset proxy_checker,chr$("proxy_type"),chr$("0"),offset pathbuf
      .endif

      invoke SendDlgItemMessage,hWnd,1048,BM_GETCHECK,0,0
      .if eax==BST_CHECKED
        invoke WritePrivateProfileString,offset proxy_checker,chr$("check_anonimity"),chr$("1"),offset pathbuf
      .else
        invoke WritePrivateProfileString,offset proxy_checker,chr$("check_anonimity"),chr$("0"),offset pathbuf
      .endif

      .if protocol==1
        invoke WritePrivateProfileString,offset proxy_checker,chr$("send_post_data"),chr$("1"),offset pathbuf
      .else
        invoke WritePrivateProfileString,offset proxy_checker,chr$("send_post_data"),chr$("0"),offset pathbuf
      .endif

      invoke SendDlgItemMessage,hWin,1053,CB_GETCURSEL,0,0
      invoke wsprintf,offset settingsbuf,chr$("%u"),eax
      invoke WritePrivateProfileString,offset proxy_checker,chr$("anon_sel"),offset settingsbuf,offset pathbuf

    .elseif wParam==1055 ;Load settings
      invoke GetPrivateProfileString,offset proxy_checker,chr$("anon_check_address"),offset emptystr,offset a_address_custom,255,offset pathbuf
      invoke GetPrivateProfileString,offset proxy_checker,chr$("anon_check_uri"),offset emptystr,offset acheck_uri_custom,255,offset pathbuf

      mov eax,offset host_address
      mov byte ptr[eax],0
      mov eax,offset divider2
      mov byte ptr[eax],0
      mov eax,offset service_uri
      mov byte ptr[eax],0
      mov eax,offset search_string
      mov byte ptr[eax],0

      invoke GetPrivateProfileString,offset proxy_checker,chr$("host"),chr$("ya.ru"),offset host_address,255,offset pathbuf
      invoke GetPrivateProfileString,offset proxy_checker,chr$("divider"),chr$(":"),offset divider2,2,offset pathbuf
      invoke GetPrivateProfileString,offset proxy_checker,chr$("service_uri"),chr$("/"),offset service_uri,255,offset pathbuf
      invoke GetPrivateProfileString,offset proxy_checker,chr$("search_string"),chr$("yandex.st"),offset search_string,511,offset pathbuf

      invoke SetDlgItemText,hWnd,1020,offset search_string
      invoke SetDlgItemText,hWnd,1019,offset host_address
      invoke SetDlgItemText,hWnd,1041,offset divider2

      invoke GetPrivateProfileString,offset proxy_checker,chr$("referer"),offset emptystr,offset referer,255,offset pathbuf
      invoke GetPrivateProfileString,offset proxy_checker,chr$("cookies"),offset emptystr,offset cookies,4095,offset pathbuf
      invoke GetPrivateProfileString,offset proxy_checker,chr$("data"),offset emptystr,get_post_data,204750,offset pathbuf

      invoke GetPrivateProfileInt,offset proxy_checker,chr$("threads"),1,offset pathbuf
      .if eax > 100
        mov eax,100
      .endif
      invoke SetDlgItemInt,hWnd,1003,eax,0
      invoke GetPrivateProfileInt,offset proxy_checker,chr$("read_bytes"),8192,offset pathbuf
      .if eax<1000 || eax>204750
        mov eax,8192
      .endif
      invoke SetDlgItemInt,hWnd,1031,eax,0
      invoke GetPrivateProfileInt,offset proxy_checker,chr$("read_timeout"),30000,offset pathbuf
      .if eax<1000 || eax>100000
        mov eax,30000
      .endif
      invoke SetDlgItemInt,hWnd,1015,eax,0
      invoke GetPrivateProfileInt,offset proxy_checker,chr$("write_timeout"),30000,offset pathbuf
      .if eax<1000 || eax>100000
        mov eax,30000
      .endif
      invoke SetDlgItemInt,hWnd,1012,eax,0


      .if FUNC(GetPrivateProfileInt,offset proxy_checker,chr$("proxy_type"),0,offset pathbuf) == 1
        invoke SendDlgItemMessage,hWnd,1004,BM_SETCHECK,1,0
      .else
        invoke SendDlgItemMessage,hWnd,1004,BM_SETCHECK,0,0
      .endif

      .if FUNC(GetPrivateProfileInt,offset proxy_checker,chr$("check_anonimity"),0,offset pathbuf) == 1
        invoke SendDlgItemMessage,hWnd,1048,BM_SETCHECK,1,0
      .else
        invoke SendDlgItemMessage,hWnd,1048,BM_SETCHECK,0,0
      .endif

      .if FUNC(GetPrivateProfileInt,offset proxy_checker,chr$("send_post_data"),0,offset pathbuf) == 1
        mov protocol,1
      .else
        mov protocol,0
      .endif

      invoke GetPrivateProfileInt,offset proxy_checker,chr$("anon_sel"),0,offset pathbuf
      .if eax > 3 || eax < 0
        mov eax,0
      .endif
      invoke SendDlgItemMessage,hWin,1053,CB_SETCURSEL,eax,0
      invoke changed_selection,hWin


    .elseif wParam==1035
      mov pauser,0
      mov stopper,0
      mov CurrProxy,0
      mov Proxies,FUNC(SendDlgItemMessage,hWnd,1001,EM_GETLINECOUNT,0,0)
      invoke SendDlgItemMessage,hWnd,1033,PBM_SETRANGE32,0,eax
      invoke SendDlgItemMessage,hWnd,1033,PBM_SETPOS,0,0


      invoke GetDlgItemInt,hWnd,1003,0,0
      mov run_thr,eax
      .if eax==0
        invoke MessageBox,hWnd,chr$("  ."),offset caption,MB_ICONERROR
        ret
      .endif


      invoke GetDlgItemInt,hWnd,1031,0,0
      mov read_bytes,eax
      .if eax<1000 || eax>204750
        invoke MessageBox,hWnd,chr$("       1000  204750."),offset caption,MB_ICONERROR
        ret
      .endif


      invoke SendDlgItemMessage,hWnd,1004,BM_GETCHECK,0,0
      .if eax==BST_CHECKED
        mov proxytype,1
      .else
        mov proxytype,0
      .endif



      invoke SendDlgItemMessage,hWnd,1048,BM_GETCHECK,0,0
      .if eax==BST_CHECKED
        mov acheck,1
      .else
        mov acheck,0
      .endif

      invoke GetDlgItemText,hWnd,1019,offset host_address,255
      test eax,eax
      jne @F
        invoke MessageBox,hWnd,chr$("    -."),offset caption,MB_ICONERROR
        ret
      @@:

      .if acheck==1
        invoke GetDlgItemText,hWnd,1049,offset a_address,255
        test eax,eax
        jne @F
          invoke MessageBox,hWnd,chr$("    -  ."),offset caption,MB_ICONERROR
          ret
        @@:

        invoke GetDlgItemText,hWnd,1051,offset acheck_uri,255
        test eax,eax
        jne @F
          invoke MessageBox,hWnd,chr$(" service_uri    -   (  ""/"")."),offset caption,MB_ICONERROR
          ret
        @@:
      .endif


      invoke GetDlgItemText,hWnd,1020,offset search_string,511
      test eax,eax
      jne @F
        invoke MessageBox,hWnd,chr$("      ."),offset caption,MB_ICONERROR
        ret
      @@:


      invoke GetDlgItemText,hWnd,1041,offset divider2,3
      test eax,eax
      jne @F
        invoke MessageBox,hWnd,chr$("     -."),offset caption,MB_ICONERROR
        ret
      @@:



      invoke GetDlgItemInt,hWnd,1012,0,0
      mov timeout_val_read,eax
      .if eax<1000 || eax>100000
        invoke MessageBox,hWnd,chr$("     ."),offset caption,MB_ICONERROR
        ret
      .endif



      invoke GetDlgItemInt,hWnd,1015,0,0
      mov timeout_val_read,eax
      .if eax<1000 || eax>100000
        invoke MessageBox,hWnd,chr$("     ."),offset caption,MB_ICONERROR
        ret
      .endif

      invoke SetDlgItemText,hWnd,1023,offset zero
      push 0
      call Show1

      invoke SendDlgItemMessage,hWnd,1001,EM_SETREADONLY,1,0

      invoke GetDlgItem,hWnd,1036
      invoke EnableWindow,eax,1
      invoke GetDlgItem,hWnd,1037
      invoke EnableWindow,eax,1



      invoke lstrlen,offset service_uri
      .if eax>0
        mov service_uri_addr,offset service_uri
      .else
        mov service_uri_addr,0
      .endif

      invoke lstrlen,offset referer
      .if eax>0
        mov referer_addr,offset referer
      .else
        mov referer_addr,0
      .endif

      invoke lstrlen,offset cookies
      .if eax>0
        mov cookies_addr,offset cookies
      .else
        mov cookies_addr,0
      .endif

      invoke lstrlen,get_post_data
      .if eax>0
        m2m get_post_data_addr,get_post_data
      .else
        mov get_post_data_addr,0
      .endif

      xor ecx,ecx

    thr_create:
      push ecx

      mov edx,ecx
      inc edx
      invoke CreateThread,0,10240,addr ProxyCheck,edx,0,0
      .if eax>0
        invoke CloseHandle,eax
      .endif

      pop ecx
      inc ecx
    .if ecx<run_thr ; 
      jmp thr_create
    .endif


    .elseif wParam==1038
      invoke MessageBox,hWnd,offset cfield,offset caption,MB_ICONQUESTION or MB_YESNO
      .if eax==IDYES
        invoke SetDlgItemText,hWnd,1005,offset zero
      .endif
    .elseif wParam==1039
      invoke MessageBox,hWnd,offset cfield,offset caption,MB_ICONQUESTION or MB_YESNO
      .if eax==IDYES
        invoke SetDlgItemText,hWnd,1007,offset zero
      .endif
    .elseif wParam==1043
      invoke MessageBox,hWnd,offset cfield,offset caption,MB_ICONQUESTION or MB_YESNO
      .if eax==IDYES
        invoke SetDlgItemText,hWnd,1047,offset zero
      .endif
    .elseif wParam==1042
      invoke DialogBoxParam,hInstance,chr$("Options"),hWnd,ADDR DialogProc2,0
    .elseif wParam==1027 || wParam==1028 || wParam==1045
      .if wParam==1027
        mov edi,1005
      .elseif wParam==1028
        mov edi,1007
      .else
        mov edi,1047
      .endif

      invoke SendDlgItemMessage,hWnd,edi,EM_SETSEL,0,-2
      invoke SendDlgItemMessage,hWnd,edi,WM_COPY,0,0
    .elseif wParam==1029
      invoke SetDlgItemText,hWnd,1001,offset zero
      invoke SendDlgItemMessage,hWnd,1001,WM_PASTE,0,0

    .elseif wParam==1036
      .if pauser==0
        mov pauser,1
        invoke SetDlgItemText,hWnd,1036,chr$("")
        invoke EnableWindow,btn2,0
      .else
        mov pauser,0
        invoke SetDlgItemText,hWnd,1036,chr$("")
        invoke EnableWindow,btn2,1
      .endif

      movzx eax,pauser
      push eax
      call PauserInit
    .elseif wParam==1037
      mov stopper,1
      invoke SetDlgItemText,hWnd,1037,chr$("...")
      invoke GetDlgItem,hWnd,1036
      invoke EnableWindow,eax,0
    .elseif wParam==1024
      invoke GetDlgItem,hWnd,1005
      invoke GetWindowTextLength,eax
      inc eax
      mov tlen,eax

      .if tlen<2
        invoke MessageBox,hWnd,chr$(" ."),offset caption,MB_ICONERROR
        ret
      .endif

      invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
      test eax,eax
      jne @F
        invoke MessageBox,hWnd,chr$("  ."),offset caption,MB_ICONERROR
        ret
    @@:

      mov fldid,eax

      invoke GetDlgItemText,hWnd,1005,fldid,tlen

      invoke SaveFileDialog2,hWnd,hInstance,chr$("  ..."),offset path,chr$("txt")
      mov fname,eax

      cmp BYTE PTR [eax],0
      jne @F
        invoke VirtualFree,fldid,0,MEM_RELEASE
        ret
    @@:

      invoke CreateFile,fname,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
      cmp eax,-1
      jne @F
        invoke VirtualFree,fldid,0,MEM_RELEASE
        invoke MessageBox,hWnd,offset fileerr,offset caption,MB_ICONERROR
        ret
    @@:

      mov iFile,eax

      dec tlen
      invoke WriteFile,iFile,fldid,tlen,offset fDone,0

      invoke VirtualFree,fldid,0,MEM_RELEASE

      invoke CloseHandle,iFile
    .elseif wParam==1025
      invoke GetDlgItem,hWnd,1007
      invoke GetWindowTextLength,eax
      inc eax
      mov tlen,eax

      .if tlen<2
        invoke MessageBox,hWnd,chr$(" ."),offset caption,MB_ICONERROR
        ret
      .endif

      invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
      test eax,eax
      jne @F
        invoke MessageBox,hWnd,chr$("  ."),offset caption,MB_ICONERROR
        ret
    @@:

      mov fldid,eax

      invoke GetDlgItemText,hWnd,1007,fldid,tlen

      invoke SaveFileDialog2,hWnd,hInstance,chr$("  ..."),offset path,chr$("txt")
      mov fname,eax

      cmp BYTE PTR [eax],0
      jne @F
        invoke VirtualFree,fldid,0,MEM_RELEASE
        ret
    @@:

      invoke CreateFile,fname,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
      cmp eax,-1
      jne @F
        invoke VirtualFree,fldid,0,MEM_RELEASE
        invoke MessageBox,hWnd,offset fileerr,offset caption,MB_ICONERROR
        ret
    @@:

      mov iFile,eax

      dec tlen
      invoke WriteFile,iFile,fldid,tlen,offset fDone,0

      invoke VirtualFree,fldid,0,MEM_RELEASE

      invoke CloseHandle,iFile

    .elseif wParam==1046
      invoke GetDlgItem,hWnd,1047
      invoke GetWindowTextLength,eax
      inc eax
      mov tlen,eax

      .if tlen<2
        invoke MessageBox,hWnd,chr$(" ."),offset caption,MB_ICONERROR
        ret
      .endif

      invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
      test eax,eax
      jne @F
        invoke MessageBox,hWnd,chr$("  ."),offset caption,MB_ICONERROR
        ret
    @@:

      mov fldid,eax

      invoke GetDlgItemText,hWnd,1047,fldid,tlen

      invoke SaveFileDialog2,hWnd,hInstance,chr$("  ..."),offset path,chr$("txt")
      mov fname,eax

      cmp BYTE PTR [eax],0
      jne @F
        invoke VirtualFree,fldid,0,MEM_RELEASE
        ret
    @@:

      invoke CreateFile,fname,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
      cmp eax,-1
      jne @F
        invoke VirtualFree,fldid,0,MEM_RELEASE
        invoke MessageBox,hWnd,offset fileerr,offset caption,MB_ICONERROR
        ret
    @@:

      mov iFile,eax

      dec tlen
      invoke WriteFile,iFile,fldid,tlen,offset fDone,0

      invoke VirtualFree,fldid,0,MEM_RELEASE

      invoke CloseHandle,iFile
    .elseif wParam==1026
      mov fname,OpenFileDlg(hWnd,hInstance,chr$(" ..."),offset path)
      cmp BYTE PTR [eax],0
      jne @F
      xor eax,eax
      ret
    @@:

      invoke CreateFile,fname,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
      cmp eax,-1
      jne @F
        invoke MessageBox,hWnd,offset fileerr,offset caption,MB_ICONERROR
        ret
    @@:

      mov iFile,eax
      invoke SetDlgItemText,hWnd,1001,offset zero

    read_again:
      invoke ReadFile,iFile,addr tempbuf,4095,offset fDone,0

      lea eax,tempbuf
      add eax,fDone
      mov byte ptr [eax],0


      invoke SendDlgItemMessage,hWnd,1001,EM_SETSEL,-2,-2
      invoke SendDlgItemMessage,hWnd,1001,EM_REPLACESEL,0,addr tempbuf
    .if fDone>0
      jmp read_again
    .endif

      invoke CloseHandle,iFile
    .endif
  .elseif uMsg == WM_CLOSE
    quit_dialog:
    .if thread_count>0
      invoke MessageBox,hWnd,chr$("     ?"),offset caption,MB_ICONQUESTION or MB_YESNO
      .if eax==IDNO
        ret
      .endif
    .endif

    call SocketCleanup
    invoke CloseHandle,hMutex
    invoke CloseHandle,hMutex_log
    invoke CloseHandle,hMutex_proxy

    invoke VirtualFree,get_post_data,0,MEM_RELEASE

    invoke DeleteObject,ico

    invoke EndDialog,hWin,0
  .endif


xor eax,eax
ret
DialogProc ENDP



ProxyCheck PROC thrnum :DWORD
LOCAL buf [256] :DWORD
LOCAL membuf :DWORD
LOCAL membuf2 :DWORD

LOCAL proxy [16] :BYTE
LOCAL port :DWORD
LOCAL errnum :DWORD

  mov membuf,0

  invoke WaitForSingleObject,hMutex,INFINITE
  cmp eax,WAIT_OBJECT_0
  je @F
    mov eax,chr$("  1")
    jmp errthr
  @@:

  inc thread_count

  invoke ReleaseMutex,hMutex

  invoke VirtualAlloc,0,204800,MEM_COMMIT,PAGE_READWRITE
  test eax,eax
  jne @F
    mov eax,offset memerr
    jmp errthr
  @@:
    mov membuf,eax

  invoke AddLog,thrnum,chr$(" ")

;;;;;;;;;;;;;;;;;;;;;;



again:
  xor eax,eax

  get_valid_proxy:
    invoke GetProxy,addr buf,addr proxy,addr port,thrnum,membuf
  .if eax==0
    jmp get_valid_proxy
  .endif

  .if eax==-1
    jmp endthr
  .endif

  .if stopper==1
    jmp endthr
  .endif

  .if pauser==1
    invoke AddLog,thrnum,offset pausetext

  pause1:
    .if pauser==1
      invoke SleepEx,1000,0
      jmp pause1
    .endif
  .endif


  invoke lstrcat,addr buf,chr$(13,10)

  invoke SendPacket,membuf,read_bytes,offset host_address,get_post_data_addr,service_uri_addr,cookies_addr,protocol,referer_addr,0,addr proxy,port,proxytype,0,0,0,0

  mov errnum,eax

  invoke InString2,1,membuf,offset search_string
  .if eax==0 || eax==-1 || eax==-2
    invoke AddLog,thrnum,chr$(" -")

    .if errnum==7
      mov eax,chr$(" IP- ")
    .elseif errnum==4
      mov eax,chr$("  ")
    .elseif errnum==2
      mov eax,chr$("  ")
    .elseif errnum==3
      mov eax,chr$("  ")
    .elseif errnum==15
      mov eax,chr$("SOCKS5    ")
    .elseif errnum==9 || errnum==8
      mov eax,chr$("     SOCKS5")
    .elseif errnum==10
      mov eax,chr$("SOCKS5  ")
    .elseif errnum==5
      mov eax,chr$("   ")
    .elseif errnum==6
      mov eax,chr$("   ")
    .else
      xor eax,eax
    .endif

    .if eax>0
      invoke AddLog,thrnum,eax
    .endif

    invoke WaitForSingleObject,hMutex_list,INFINITE
    cmp eax,WAIT_OBJECT_0
    je @F
      mov eax,chr$(" ")
      jmp errthr
    @@:

      invoke SendDlgItemMessage,hWnd,1007,EM_SETSEL,-2,-2
      invoke SendDlgItemMessage,hWnd,1007,EM_REPLACESEL,0,addr buf

      invoke ReleaseMutex,hMutex_list
    jmp again
  .endif

    invoke AddLog,thrnum,chr$(" -")

    invoke WaitForSingleObject,hMutex_list,INFINITE
    cmp eax,WAIT_OBJECT_0
    je @F
      mov eax,chr$(" ")
      jmp errthr
    @@:

      invoke SendDlgItemMessage,hWnd,1005,EM_SETSEL,-2,-2
      invoke SendDlgItemMessage,hWnd,1005,EM_REPLACESEL,0,addr buf

      invoke ReleaseMutex,hMutex_list

    .if acheck==1
      invoke AddLog,thrnum,chr$("  ")
      invoke SendPacket,membuf,200000,offset a_address,0,offset acheck_uri,0,0,0,0,addr proxy,port,proxytype,0,0,0,0
      invoke InString2,1,membuf,addr proxy
      .if eax!=0 && eax!=-1 && eax!=-2
        invoke AddLog,thrnum,chr$(" ")

        invoke WaitForSingleObject,hMutex_list,INFINITE
        cmp eax,WAIT_OBJECT_0
        je @F
          mov eax,chr$(" ")
          jmp errthr
        @@:

          invoke SendDlgItemMessage,hWnd,1047,EM_SETSEL,-2,-2
          invoke SendDlgItemMessage,hWnd,1047,EM_REPLACESEL,0,addr buf

          invoke ReleaseMutex,hMutex_list
      .else
        invoke AddLog,thrnum,chr$(" ")
      .endif
    .endif
jmp again


errthr:
  invoke AddLog,thrnum,eax


endthr:
  .if membuf>0
    invoke VirtualFree,membuf,0,MEM_RELEASE
  .endif

  invoke WaitForSingleObject,hMutex,INFINITE
  cmp eax,WAIT_OBJECT_0
  je @F
    mov eax,chr$(" ")
    jmp errthr
  @@:

  dec thread_count

  invoke ReleaseMutex,hMutex

  .if thread_count==0
    mov pauser,0
    invoke SetDlgItemText,hWnd,1036,chr$("")


    push 1
    call Show1

    invoke SendDlgItemMessage,hWnd,1001,EM_SETREADONLY,0,0

    invoke GetDlgItem,hWnd,1036
    invoke EnableWindow,eax,0
    invoke GetDlgItem,hWnd,1037
    invoke EnableWindow,eax,0

    invoke SetDlgItemText,hWnd,1037,chr$("")


  .endif

  invoke AddLog,thrnum,chr$("Quit")
  invoke ExitThread,0
ret
ProxyCheck ENDP



GetProxy PROC buf :DWORD, proxy :DWORD, port :DWORD, thrnum :DWORD, membuf :DWORD
LOCAL isproxy  :DWORD
LOCAL CID [36] :BYTE

  mov isproxy,0

  invoke WaitForSingleObject,hMutex_proxy,INFINITE
  cmp eax,WAIT_OBJECT_0
  je @F
    invoke ReleaseMutex,hMutex_proxy
    xor eax,eax
    ret
  @@:

  nextproxy:

  mov eax,buf
  mov word ptr [eax],252

  invoke SendDlgItemMessage,hWnd,1033,PBM_SETPOS,CurrProxy,0
  invoke SendDlgItemMessage,hWnd,1001,EM_GETLINE,CurrProxy,buf

  inc CurrProxy

  mov ecx,Proxies
  .if CurrProxy>ecx
    invoke ReleaseMutex,hMutex_proxy
    mov eax,-1
    ret
  .endif

  .if eax==0
    jmp nextproxy
  .endif


  invoke InString2,1,buf,offset divider2
  .if eax==0 || eax==-1 || eax==-2
    jmp nextproxy
  .endif



  push eax
  .if eax>15
    mov eax,15
  .endif

  invoke lstrcpyn,proxy,buf,eax
  pop eax

  mov ebx,buf
  add ebx,eax

  mov esi,ebx

  invoke atodw,ebx
  mov ecx,port
  mov dword ptr [ecx],eax
  .if eax>65535 || eax==0
    invoke AddLog,thrnum,offset badproxy
    jmp nextproxy
  .endif


  invoke lstrlen,esi
  .if eax==0
    invoke AddLog,thrnum,offset badproxy
    jmp nextproxy
  .endif

  mov ecx,eax

  ch1:
    .if byte ptr [esi+ecx-1]<'0' || byte ptr [esi+ecx-1]>'9'
      invoke AddLog,thrnum,offset badproxy
      jmp nextproxy
    .endif
  loop ch1



  invoke lstrcpy,addr CID,proxy

  lea esi,CID
  xor edi,edi

  chagain:

  inc edi



  invoke InString2,1,esi,chr$(".")
  .if eax==0 || eax==-1 || eax==-2
    invoke AddLog,thrnum,offset badproxy
    jmp nextproxy
  .endif


  add eax,esi
  dec eax
  mov byte ptr [eax],0

  invoke atodw,esi
  .if eax>255
    invoke AddLog,thrnum,offset badproxy
    jmp nextproxy
  .endif

  invoke lstrlen,esi
  .if eax==0
    invoke AddLog,thrnum,offset badproxy
    jmp nextproxy
  .endif

  mov ecx,eax

  ch2:
    .if byte ptr [esi+ecx-1]<'0' || byte ptr [esi+ecx-1]>'9'
      invoke AddLog,thrnum,offset badproxy
      jmp nextproxy
    .endif
  loop ch2

  add esi,eax
  inc esi

  .if edi<3
    jmp chagain
  .endif



  invoke atodw,esi
  .if eax>255
    invoke AddLog,thrnum,offset badproxy
    jmp nextproxy
  .endif

  invoke lstrlen,esi
  .if eax==0
    invoke AddLog,thrnum,offset badproxy
    jmp nextproxy
  .endif

  mov ecx,eax

  ch3:
    .if byte ptr [esi+ecx-1]<'0' || byte ptr [esi+ecx-1]>'9'
      invoke AddLog,thrnum,offset badproxy
      jmp nextproxy
    .endif
  loop ch3

  .if proxytype==0
    invoke lstrcpy,membuf,chr$(": ")
  .else
    invoke lstrcpy,membuf,chr$("SOCKS5: ")
  .endif

  invoke lstrcat,membuf,buf
  invoke AddLog,thrnum,membuf

  mov isproxy,1


  endproxyfind:


  invoke ReleaseMutex,hMutex_proxy

  mov eax,isproxy
ret
GetProxy ENDP


AddLog PROC thrnum :DWORD, xstr :DWORD
  LOCAL buf [384] :BYTE
  LOCAL buf22 [8] :BYTE

  invoke WaitForSingleObject,hMutex_log,INFINITE
  cmp eax,WAIT_OBJECT_0
  je @F
    ret
  @@:

  inc lognum
  .if lognum>500
    invoke SetDlgItemText,hWnd,1023,offset zero
    mov lognum,0
  .endif

  invoke lstrcpy,addr buf,chr$("Thr#")
  invoke wsprintf,addr buf22,chr$("%u"),thrnum
  invoke lstrcat,addr buf,addr buf22
  invoke lstrcat,addr buf,chr$(": ")
  invoke lstrcat,addr buf,xstr
  invoke lstrcat,addr buf,chr$(13,10)
  invoke SendDlgItemMessage,hWnd,1023,EM_SETSEL,-2,-2
  invoke SendDlgItemMessage,hWnd,1023,EM_REPLACESEL,0,addr buf

  invoke ReleaseMutex,hMutex_log

ret
AddLog ENDP




SendPacket PROC \
  http_ans_buffer :DWORD, \
  http_ans_buffer_len :DWORD, \
  http_host :DWORD, \
  http_data :DWORD, \
  http_service_uri :DWORD, \
  http_cookies :DWORD, \
  http_method :DWORD, \
  http_referer :DWORD, \
  http_add_headers :DWORD, \
  http_proxy_ip :DWORD, \
  http_proxy_port :DWORD, \
  http_proxy_type :DWORD, \
  http_proxy_user :DWORD, \
  http_proxy_pass :DWORD, \
  http_port :DWORD, \
  http_answer_size :DWORD

  LOCAL bConnected :BYTE
  LOCAL bAllocated :BYTE
  LOCAL socks5_allocated :BYTE
  LOCAL iSock :DWORD

  LOCAL total_length :DWORD
  LOCAL http_membuf :DWORD
  LOCAL data_len :DWORD
  LOCAL http_service_uri_len :DWORD
  LOCAL proxy_pass_len :DWORD

  LOCAL text_to_encode :DWORD

  LOCAL bytes_to_read :DWORD

  LOCAL len_buffer [12] :BYTE

  LOCAL socks5_buf :DWORD

  LOCAL http_packet_length :DWORD

  LOCAL SocketAddress :sockaddr_in


  .data
    method_post db "POST ",0
    method_get db "GET ",0

    poststr1 db " HTTP/1.0",13,10, \
                "Host: ",0
    poststr2 db 13,10, \
                "Connection: close",13,10, \
                "Content-Length: ",0

    poststr3 db 13,10,0

    poststr5 db "Content-type: application/x-www-form-urlencoded",13,10,0

    referer_str db "Referer: ",0
    cookies_str db "Cookie: ",0
    http_sym db "http://",0

    default_service_uri db "/",0

    proxy_pass db "Proxy-Authorization: Basic ",0
    proxy_sym db ":",0
    get_query_sym db  "?",0

    socks5_auth_packet db 05,02,00,02

  .code
    push esi
    push edi
    push ebx


    mov eax,http_ans_buffer
    mov byte ptr [eax],0

    mov bConnected,0
    mov bAllocated,0
    mov socks5_allocated,0

    m2m total_length,http_host

    .if http_data!=0
      mov data_len,FUNC(lstrlen,http_data)
      add total_length,eax
      inc total_length
    .endif

    .if http_service_uri!=0
      mov http_service_uri_len,FUNC(lstrlen,http_service_uri)
      add total_length,eax
    .else
      inc total_length
    .endif

    .if http_cookies!=0
      add total_length,FUNC(lstrlen,http_cookies)
      add total_length,10
    .endif

    .if http_referer!=0
      add total_length,FUNC(lstrlen,http_referer)
      add total_length,11
    .endif

    .if http_add_headers!=0
      add total_length,FUNC(lstrlen,http_add_headers)
    .endif

    add total_length,73

    .if http_method==1
      add total_length,49
    .endif

    .if http_proxy_user!=0 && http_proxy_type==0
      add total_length,29

      mov proxy_pass_len,FUNC(lstrlen,http_proxy_user)
      add proxy_pass_len,FUNC(lstrlen,http_proxy_pass)
      add proxy_pass_len,2

      mov eax,proxy_pass_len


      xor edx,edx
      mov ebx,3
      mul ebx
      xor edx,edx
      mov ebx,2
      div ebx
      add eax,5

      add total_length,eax
      mov proxy_pass_len,eax
    .endif

    .if http_proxy_ip!=0
      add total_length,13

      .if http_service_uri!=0
        mov eax,http_service_uri_len
        add total_length,eax
      .else
        inc total_length
      .endif
    .endif

    .if http_proxy_ip==0
      invoke gethostbyname,http_host
      test eax,eax
      jne @F
        mov eax,1 ;error resolving hostname
        jmp http_err
    @@:

      mov eax,[eax+12]
      mov eax,[eax]
      mov eax,[eax]
    .else
      invoke inet_addr,http_proxy_ip

      cmp eax,INADDR_NONE
      jne @F
        mov eax,7 ;error in proxy IP
        jmp http_err
    @@:

    .endif


    MOV SocketAddress.sin_addr,EAX

    .if http_proxy_port!=0
      invoke htons,http_proxy_port
    .elseif http_port==0
      invoke htons,80
    .else
      invoke htons,http_port
    .endif

    mov SocketAddress.sin_port,AX

    MOV SocketAddress.sin_family,AF_INET


    invoke VirtualAlloc,0,total_length,MEM_COMMIT,PAGE_READWRITE
    .if eax==0
      mov eax,4 ;error allocating memory
      jmp http_err
    .endif

    mov http_membuf,eax
    mov bAllocated,1


    .if http_method==0
      mov eax,offset method_get
    .else
      mov eax,offset method_post
    .endif

    invoke lstrcpy,http_membuf,eax

    .if http_proxy_ip!=0 && http_proxy_type==0
      invoke lstrcat,http_membuf,offset http_sym
      invoke lstrcat,http_membuf,http_host
      invoke lstrcat,http_membuf,offset proxy_sym

      .if http_port==0
        mov eax,80
      .else
        mov eax,http_port
      .endif

      invoke wsprintf,addr len_buffer,chr$("%u"),eax
      invoke lstrcat,http_membuf,addr len_buffer
    .endif

    .if http_service_uri==0
      mov eax,offset default_service_uri
    .else
      mov eax,http_service_uri
    .endif

    invoke lstrcat,http_membuf,eax

    .if http_method==0 && http_data!=0
      invoke lstrcat,http_membuf,offset get_query_sym
      invoke lstrcat,http_membuf,http_data
    .endif


    invoke lstrcat,http_membuf,offset poststr1
    invoke lstrcat,http_membuf,http_host
    invoke lstrcat,http_membuf,offset poststr2


    .if http_method==0 || http_data==0
      xor eax,eax
    .else
      mov eax,data_len
    .endif


    invoke wsprintf,addr len_buffer,chr$("%u"),eax
    invoke lstrcat,http_membuf,addr len_buffer
    invoke lstrcat,http_membuf,offset poststr3

    .if http_method==1
      invoke lstrcat,http_membuf,offset poststr5
    .endif

    .if http_referer!=0
      invoke lstrcat,http_membuf,offset referer_str
      invoke lstrcat,http_membuf,http_referer
      invoke lstrcat,http_membuf,offset poststr3
    .endif

    .if http_cookies!=0
      invoke lstrcat,http_membuf,offset cookies_str
      invoke lstrcat,http_membuf,http_cookies
      invoke lstrcat,http_membuf,offset poststr3
    .endif

    .if http_add_headers!=0
      invoke lstrcat,http_membuf,http_add_headers
    .endif


    .if http_proxy_user!=0 && http_proxy_type==0
      invoke lstrcat,http_membuf,offset proxy_pass

      invoke VirtualAlloc,0,proxy_pass_len,MEM_COMMIT,PAGE_READWRITE
      .if eax==0
        mov eax,4 ;error allocating memory
        jmp http_err
      .endif

      mov text_to_encode,eax
      invoke lstrcpy,text_to_encode,http_proxy_user
      invoke lstrcat,text_to_encode,offset proxy_sym
      invoke lstrcat,text_to_encode,http_proxy_pass

      invoke lstrlen,http_membuf
      add eax,http_membuf
      invoke base64_encode,text_to_encode,eax,proxy_pass_len,0

      invoke VirtualFree,text_to_encode,0,MEM_RELEASE

      invoke lstrcat,http_membuf,offset poststr3
    .endif



    invoke lstrcat,http_membuf,offset poststr3

    .if http_method==1 && http_data!=0
      invoke lstrcat,http_membuf,http_data
    .endif



    mov total_length,FUNC(lstrlen,http_membuf)

    invoke socket,AF_INET,SOCK_STREAM,IPPROTO_TCP
    CMP EAX,INVALID_SOCKET
    jne @F
      mov eax,2 ;error creating socket
      jmp http_err
  @@:

    mov iSock,eax

    invoke setsockopt,iSock,SOL_SOCKET,SO_RCVTIMEO,addr timeout_val_read,sizeof timeout_val_read

    invoke setsockopt,iSock,SOL_SOCKET,SO_SNDTIMEO,addr timeout_val_write,sizeof timeout_val_write

    invoke connect,iSock,addr SocketAddress,sizeof sockaddr_in
    test eax,eax
    je @F
      mov eax,3 ;error connecting to socket
      jmp http_err
  @@:

    mov bConnected,1



    .if http_proxy_ip!=0 && http_proxy_type==1
      invoke send,iSock,offset socks5_auth_packet,4,0
      cmp eax,4
      je @F
        mov eax,8 ;error sending socks5 authorization packet
        jmp http_err
    @@:


      invoke VirtualAlloc,0,550,MEM_COMMIT,PAGE_READWRITE
      .if eax==0
        mov eax,4 ;error allocating memory
        jmp http_err
      .endif

      mov socks5_buf,eax
      mov socks5_allocated,1

      invoke recv,iSock,eax,4,0
      cmp eax,-1
      jne @F
        mov eax,9 ;error receiving socks5 authorization packet
        jmp http_err
    @@:

      mov edi,socks5_buf
      mov ax,word ptr [edi]


      .if ax==0000001000000101b
        .if http_proxy_user==0
          mov eax,15 ;socks5 server requires authorization
          jmp http_err
        .endif



        mov ecx,FUNC(lstrlen,http_proxy_user)
        push ecx
        mov edx,FUNC(lstrlen,http_proxy_pass)
        pop ecx

        .if ecx>255
          mov ecx,255
        .endif

        .if edx>255
          mov edx,255
        .endif

        mov ebx,socks5_buf
        mov byte ptr [ebx],01
        inc ebx
        mov byte ptr [ebx],cl
        inc ebx

        push ebx
        push edx
        push ecx
        invoke lstrcpyn,ebx,http_proxy_user,255
        pop ecx
        pop edx
        pop ebx

        add ebx,ecx

        mov byte ptr [ebx],dl
        inc ebx

        invoke lstrcpyn,ebx,http_proxy_pass,255



        invoke lstrlen,socks5_buf

        push eax
        invoke send,iSock,socks5_buf,eax,0
        pop ebx
        cmp eax,ebx
        je @F
          mov eax,8 ;error sending socks5 authorization packet
          jmp http_err
      @@:


        invoke recv,iSock,socks5_buf,4,0
        cmp eax,-1
        jne @F
          mov eax,9 ;error receiving socks5 authorization packet
          jmp http_err
      @@:

        mov edi,socks5_buf
        mov ax,word ptr [edi]


        .if ah!=0
          mov eax,11 ;wrong socks5 user or password
          jmp http_err
        .endif

      .elseif ax!=0000000000000101b
        mov eax,10 ;unknown socks5 server
        jmp http_err
      .endif


      mov ecx,FUNC(lstrlen,http_host)

      .if ecx>255
        mov ecx,255
      .endif



      mov edi,socks5_buf
      mov byte ptr [edi],05
      mov byte ptr [edi+1],01
      mov byte ptr [edi+2],00
      mov byte ptr [edi+3],03

      add edi,4
      mov byte ptr [edi],cl
      inc edi
      push ecx
      invoke lstrcpyn,edi,http_host,255
      pop ecx
      add edi,ecx

      .if http_port==0
        mov eax,80
      .else
        mov eax,http_port
      .endif

      xchg al,ah
      mov word ptr [edi],ax
      add edi,2
      sub edi,socks5_buf


      invoke send,iSock,socks5_buf,edi,0
      cmp eax,edi
      je @F
        mov eax,8 ;error sending socks5 authorization packet
        jmp http_err
    @@:


      invoke recv,iSock,socks5_buf,100,0
      cmp eax,-1
      jne @F
        mov eax,9 ;error receiving socks5 authorization packet
        jmp http_err
    @@:

      mov edi,socks5_buf
      mov ax,word ptr [edi]

      .if ah!=0
        mov eax,14 ;error connecting to socks5 server
        jmp http_err
      .endif

      invoke VirtualFree,socks5_buf,0,MEM_RELEASE

      mov socks5_allocated,0

    .endif



    invoke send,iSock,http_membuf,total_length,0
    cmp eax,total_length
    je @F
      mov eax,5 ;error sending packet
      jmp http_err
  @@:


    invoke VirtualFree,http_membuf,0,MEM_RELEASE
    mov bAllocated,0



    mov edi,http_ans_buffer
    xor ecx,ecx

  sread:
    m2m bytes_to_read,http_ans_buffer_len
    sub bytes_to_read,ecx
    dec bytes_to_read

    .if bytes_to_read==0
      jmp http_end_read
    .endif

    .if bytes_to_read>128
      mov bytes_to_read,128
    .endif

    push ecx
    invoke recv,iSock,edi,bytes_to_read,0
    pop ecx

    cmp eax,-1
    jne @F
      mov eax,6 ;error reading from socket
      mov byte ptr [edi],0
      jmp http_err
  @@:


    add edi,eax
    add ecx,eax

    test eax,eax
  jne sread

  http_end_read:

  .if http_answer_size!=0
    mov eax,http_answer_size
    mov dword ptr [eax],ecx
  .endif


  mov byte ptr [edi],0

  invoke closesocket,iSock
  mov bConnected,0

  xor eax,eax
  pop ebx
  pop edi
  pop esi
ret

  http_err:

  push eax

  .if bConnected==1
    invoke closesocket,iSock
  .endif

  .if bAllocated==1
    invoke VirtualFree,http_membuf,0,MEM_RELEASE
  .endif

  .if socks5_allocated==1
    invoke VirtualFree,socks5_buf,0,MEM_RELEASE
  .endif

  pop eax

  pop ebx
  pop edi
  pop esi
ret
SendPacket ENDP


base64_encode PROC \
  string_to_encode :DWORD,  \
  result_buffer :DWORD, \
  result_buffer_length :DWORD, \
  data_length :DWORD

  LOCAL currlength :DWORD
  LOCAL textlen :DWORD

  LOCAL chr1 :BYTE
  LOCAL chr2 :BYTE
  LOCAL chr3 :BYTE
  LOCAL chr4 :BYTE

  LOCAL enc1 :BYTE
  LOCAL enc2 :BYTE
  LOCAL enc3 :BYTE
  LOCAL enc4 :BYTE


  push edi
  push esi
  push ebx


  mov esi,result_buffer
  mov currlength,0

  .if data_length==0
    invoke lstrlen,string_to_encode
    mov textlen,eax
  .else
    m2m textlen,data_length
  .endif

  mov edi,string_to_encode


  again:
    mov al,byte ptr [edi]
    mov chr1,al
    inc edi

    .if al==0
      mov chr2,0
      mov chr3,0
    .else
      mov bl,byte ptr [edi]
      mov chr2,bl
      inc edi

      .if bl==0
        mov chr3,0
      .else
        mov cl,byte ptr [edi]
        mov chr3,cl
        inc edi
      .endif
    .endif

    mov al,chr1
    shr al,2
    mov enc1,al

    mov al,chr1
    and al,3
    shl al,4
    mov bl,chr2
    shr bl,4
    or al,bl
    mov enc2,al

    mov al,chr2
    and al,15
    shl al,2
    mov bl,chr3
    shr bl,6
    or al,bl
    mov enc3,al

    mov al,chr3
    and al,63
    mov enc4,al

    mov al,chr2
    .if al==0
      mov enc3,64
      mov enc4,64
    .else
      mov bl,chr3
      .if bl==0
        mov enc4,64
      .endif
    .endif

    movzx ecx,enc1
    add ecx,offset keyStr
    mov cl,byte ptr [ecx]
    mov byte ptr [esi],cl
    inc esi

    movzx ecx,enc2
    add ecx,offset keyStr
    mov cl,byte ptr [ecx]
    mov byte ptr [esi],cl
    inc esi

    movzx ecx,enc3
    add ecx,offset keyStr
    mov cl,byte ptr [ecx]
    mov byte ptr [esi],cl
    inc esi

    movzx ecx,enc4
    add ecx,offset keyStr
    mov cl,byte ptr [ecx]
    mov byte ptr [esi],cl
    inc esi

    mov ebx,esi
    sub ebx,result_buffer
    cmp ebx,result_buffer_length-5
    jb @F
      jmp base64_exitloop
  @@:

    add currlength,3
    mov edx,currlength
    cmp edx,textlen
    jb again
  base64_exitloop:

  mov byte ptr [esi],0

  pop ebx
  pop esi
  pop edi

ret
base64_encode ENDP



SocketInit PROC
  LOCAL WSAStruct :WSADATA
;0101h
  invoke WSAStartup,514,addr WSAStruct
  ret
SocketInit ENDP

SocketCleanup PROC
  call WSACleanup
  ret
SocketCleanup ENDP




align 4

SaveFileDialog2 proc hParent:DWORD,Instance:DWORD,lpTitle:DWORD,lpFilter:DWORD,defext:DWORD
    LOCAL ofn:OPENFILENAME

    .data?
      savefilebuffer db 260 dup (?)
    .code

    mov eax, OFFSET savefilebuffer
    mov BYTE PTR [eax], 0

    push edi
    mov ecx, sizeof OPENFILENAME
    mov al, 0
    lea edi, ofn
    rep stosb
    pop edi

    mov ofn.lStructSize,        sizeof OPENFILENAME
    m2m ofn.hWndOwner,          hParent
    m2m ofn.hInstance,          Instance
    m2m ofn.lpstrFilter,        lpFilter
    m2m ofn.lpstrFile,          offset savefilebuffer
    mov ofn.nMaxFile,           sizeof savefilebuffer
    m2m ofn.lpstrTitle,         lpTitle
    mov ofn.Flags,              OFN_EXPLORER or OFN_LONGNAMES or \
                                OFN_HIDEREADONLY or OFN_OVERWRITEPROMPT

    m2m ofn.lpstrDefExt,defext
                                
    invoke GetSaveFileName,ADDR ofn
    mov eax, OFFSET savefilebuffer
    ret

SaveFileDialog2 endp








InString2 proc startpos:DWORD,lpSource:DWORD,lpPattern:DWORD

    LOCAL sLen:DWORD
    LOCAL pLen:DWORD

    push ebx
    push esi
    push edi

    invoke lstrlen,lpSource
    mov sLen, eax           ; source length
    invoke lstrlen,lpPattern
    mov pLen, eax           ; pattern length

    cmp startpos, 1
    jge @F
    mov eax, -2
    jmp isOut               ; exit if startpos not 1 or greater
  @@:

    dec startpos            ; correct from 1 to 0 based index

    cmp  eax, sLen
    jl @F
    mov eax, -1
    jmp isOut               ; exit if pattern longer than source
  @@:

    sub sLen, eax           ; don't read past string end
    inc sLen

    mov ecx, sLen
    cmp ecx, startpos
    jg @F
    mov eax, -2
    jmp isOut               ; exit if startpos is past end
  @@:

  ; ----------------
  ; setup loop code
  ; ----------------
    mov esi, lpSource
    mov edi, lpPattern
    mov al, [edi]           ; get 1st char in pattern

    add esi, ecx            ; add source length
    neg ecx                 ; invert sign
    add ecx, startpos       ; add starting offset

    jmp Scan_Loop

    align 16

  ; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  Pre_Scan:
    inc ecx                 ; start on next byte

  Scan_Loop:
    cmp al, [esi+ecx]       ; scan for 1st byte of pattern
    je Pre_Match            ; test if it matches
    inc ecx
    js Scan_Loop            ; exit on sign inversion

    jmp No_Match

  Pre_Match:
    lea ebx, [esi+ecx]      ; put current scan address in EBX
    mov edx, pLen           ; put pattern length into EDX

  Test_Match:
    mov ah, [ebx+edx-1]     ; load last byte of pattern length in main string
    cmp ah, [edi+edx-1]     ; compare it with last byte in pattern
    jne Pre_Scan            ; jump back on mismatch
    dec edx
    jnz Test_Match          ; 0 = match, fall through on match

  ; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  Match:
    add ecx, sLen
    mov eax, ecx
    inc eax
    jmp isOut
    
  No_Match:
    xor eax, eax

  isOut:
    pop edi
    pop esi
    pop ebx

    ret

InString2 endp










ExceptionHandler PROC pointr :DWORD
  LOCAL buf [128] :BYTE
  mov stopper,1

  mov eax,pointr
  mov eax,EXCEPTION_POINTERS.pExceptionRecord[eax]
  mov edx,EXCEPTION_RECORD.ExceptionCode[eax]
  mov ecx,EXCEPTION_RECORD.ExceptionAddress[eax]


  invoke wsprintf,addr buf,chr$("  !",13,10," : %u",13,10," : %u",13,10,"   !     ?"),ecx,edx


  invoke MessageBox,0,addr buf,chr$("Fatal Error"),MB_ICONERROR or MB_YESNO

  .if eax==IDYES
    invoke GetDlgItem,hWnd,1005
    invoke GetWindowTextLength,eax
    inc eax
    mov tlen,eax

    .if tlen<2
      invoke MessageBox,hWnd,chr$(" ."),offset caption,MB_ICONERROR
      jmp fatalexit
    .endif

    invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
    test eax,eax
    jne @F
      invoke MessageBox,hWnd,chr$("  ."),offset caption,MB_ICONERROR
      jmp fatalexit
  @@:

    mov fldid,eax

    invoke GetDlgItemText,hWnd,1005,fldid,tlen

    invoke SaveFileDialog2,hWnd,hInstance,chr$("  ..."),offset path,chr$("txt")
    mov fname,eax

    cmp BYTE PTR [eax],0
    jne @F
    invoke VirtualFree,fldid,0,MEM_RELEASE
    xor eax,eax
    jmp fatalexit
  @@:

    invoke CreateFile,fname,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
    cmp eax,-1
    jne @F
      invoke VirtualFree,fldid,0,MEM_RELEASE
      invoke MessageBox,hWnd,offset fileerr,offset caption,MB_ICONERROR
      jmp fatalexit
  @@:

    mov iFile,eax

    invoke WriteFile,iFile,fldid,tlen,offset fDone,0

    invoke VirtualFree,fldid,0,MEM_RELEASE

    invoke CloseHandle,iFile
  .endif

  fatalexit:


  invoke MessageBox,0,chr$("    ?"),chr$("Fatal Error"),MB_ICONERROR or MB_YESNO

  .if eax==IDYES
    invoke GetDlgItem,hWnd,1007
    invoke GetWindowTextLength,eax
    inc eax
    mov tlen,eax

    .if tlen<2
      invoke MessageBox,hWnd,chr$(" ."),offset caption,MB_ICONERROR
      jmp fatalexit2
    .endif

    invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
    test eax,eax
    jne @F
      invoke MessageBox,hWnd,chr$("  ."),offset caption,MB_ICONERROR
      jmp fatalexit2
  @@:

    mov fldid,eax

    invoke GetDlgItemText,hWnd,1007,fldid,tlen

    invoke SaveFileDialog2,hWnd,hInstance,chr$("  ..."),offset path,chr$("txt")
    mov fname,eax

    cmp BYTE PTR [eax],0
    jne @F
    invoke VirtualFree,fldid,0,MEM_RELEASE
    xor eax,eax
    jmp fatalexit2
  @@:

    invoke CreateFile,fname,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
    cmp eax,-1
    jne @F
      invoke VirtualFree,fldid,0,MEM_RELEASE
      invoke MessageBox,hWnd,offset fileerr,offset caption,MB_ICONERROR
      jmp fatalexit2
  @@:

    mov iFile,eax

    invoke WriteFile,iFile,fldid,tlen,offset fDone,0

    invoke VirtualFree,fldid,0,MEM_RELEASE

    invoke CloseHandle,iFile
  .endif




  fatalexit2:



  invoke MessageBox,0,chr$("    ?"),chr$("Fatal Error"),MB_ICONERROR or MB_YESNO

  .if eax==IDYES
    invoke GetDlgItem,hWnd,1047
    invoke GetWindowTextLength,eax
    inc eax
    mov tlen,eax

    .if tlen<2
      invoke MessageBox,hWnd,chr$(" ."),offset caption,MB_ICONERROR
      jmp fatalexit2
    .endif

    invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
    test eax,eax
    jne @F
      invoke MessageBox,hWnd,chr$("  ."),offset caption,MB_ICONERROR
      jmp fatalexit2
  @@:

    mov fldid,eax

    invoke GetDlgItemText,hWnd,1047,fldid,tlen

    invoke SaveFileDialog2,hWnd,hInstance,chr$("  ..."),offset path,chr$("txt")
    mov fname,eax

    cmp BYTE PTR [eax],0
    jne @F
    invoke VirtualFree,fldid,0,MEM_RELEASE
    xor eax,eax
    jmp fatalexit2
  @@:

    invoke CreateFile,fname,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
    cmp eax,-1
    jne @F
      invoke VirtualFree,fldid,0,MEM_RELEASE
      invoke MessageBox,hWnd,offset fileerr,offset caption,MB_ICONERROR
      jmp fatalexit2
  @@:

    mov iFile,eax

    invoke WriteFile,iFile,fldid,tlen,offset fDone,0

    invoke VirtualFree,fldid,0,MEM_RELEASE

    invoke CloseHandle,iFile
  .endif

  fatalexit3:

  invoke ExitProcess,0
  xor eax,eax
ret
ExceptionHandler ENDP



Show1 PROC endis :DWORD
  .data
    ids1 dw 1029,1026,1024,1027,1025,1028,1010,1012,1015,1019,1020,1031,1041,1035,1004,1038,1039,1042,1043,1045,1046,1051,1049,1048,1053,1054,1055
  .code
  invoke ShowElems,offset ids1,27,endis
ret
Show1 ENDP

ShowElems PROC dat :DWORD,num :DWORD,endis :DWORD
    mov ecx,num
    lp:
      push ecx
      mov eax,dat
      movzx eax,word ptr [eax+ecx*2-2]
      invoke GetDlgItem,hWnd,eax
      invoke EnableWindow,eax,endis
      pop ecx
    loop lp
ret
ShowElems ENDP



PauserInit PROC ps :DWORD
  invoke GetDlgItem,hWnd,1024
  invoke EnableWindow,eax,ps
  invoke GetDlgItem,hWnd,1027
  invoke EnableWindow,eax,ps
  invoke GetDlgItem,hWnd,1038
  invoke EnableWindow,eax,ps
  invoke GetDlgItem,hWnd,1028
  invoke EnableWindow,eax,ps
  invoke GetDlgItem,hWnd,1025
  invoke EnableWindow,eax,ps
  invoke GetDlgItem,hWnd,1039
  invoke EnableWindow,eax,ps
ret
PauserInit ENDP


end start